import os
from flask import Flask, request, render_template, url_for, redirect
from werkzeug import secure_filename
import pricolor
app = Flask(__name__)

UPLOAD_FOLDER = '/tmp'
ALLOWED_EXTENSIONS = set(['PNG','JPG','JPEG','GIF','png', 'jpg', 'jpeg', 'gif'])
MAX_SIZE=1024*1024*2

def allowed_file(filename):
    return '.' in filename and \
           filename.rsplit('.', 1)[1] in ALLOWED_EXTENSIONS

app.config['UPLOAD_FOLDER'] = UPLOAD_FOLDER

@app.route('/')
def index():
    return render_template('upload.html')

@app.route('/download')
def download():
    return 'hello world'

@app.route('/upload', methods=['GET','POST'])
def upload():
    if request.method == 'POST':
	file = request.files['pic']
        if file and allowed_file(file.filename):
            filename = secure_filename(file.filename)
            filepath = os.path.join(app.config['UPLOAD_FOLDER'], filename)
	    file.save(filepath)
    	    ret = pricolor.rf(filepath)
	    return render_template('custom.html',ret=ret)
    return 'only can post'

if __name__ == '__main__':
    app.run(debug=True)
